package sim.app.sensor_emitter;

/**
 * Contains the algorithm that moves an agent.  Called by the step() function.
 * 
 * @author Adam Campbell
 */
abstract class AgentMover{

	/**
	 * Specifies how an agent <code>a</code> moves around in the environment
	 *
	 * @param a agent to be moved
	 * @param sim the simulation that the agent is in
	 */
	protected abstract void move(final Agent a, final Simulation sim);
}