package sim.app.sensor_emitter;

/**
 * Contains the algorithm that controls how sensors change which frequency they monitor.
 * Called by the step() function.
 * 
 * @author Adam Campbell
 */
abstract class FrequencyUpdater{

	/**
	 * Controls how sensor <code>s</code> controls which frequency it monitors.
	 *
	 * @param s the sensor
	 * @param sim the simulation that the sensor is in
	 */
	protected abstract void update(final Sensor s, final Simulation sim);
}