package sim.app.sensor_emitter;

/**
 * Contains the information sent when a sensor broadcasts to its neighboring sensors.
 *
 * @author Adam Campbell
 */
class Message{

	/** id of the sensor that this message came from */
	protected int fromID;
		
	/** simulation time step that this message was originally sent */
	protected long timeStamp;
	
	/** frequency of the sending sensor when it sent the message */
	protected int frequency;

	/**
	 * Constructor.
	 *
	 * @param id ID of the sending sensor
	 * @param time time that this message was sent
	 * @param freq frequency of the sending sensor when it sent the message
	 */
	public Message(final int id, final long time, final int freq){

		this.fromID = id;
		this.timeStamp = time;
		this.frequency = freq;
	}
}