package sim.app.sensor_emitter;

/**
 * Implements Method3 from AAMAS 2009 paper (Campbell and Wu).
 * Randomly changes the frequency of the sensor.
 * Note, this algorithm allows for sensors to 'switch-to' the frequency that they are already sensing.
 * 
 * @author Adam Campbell
 */
class Method3FrequencyUpdater extends FrequencyUpdater{

	/**
	 * Constructor
	 */
	public Method3FrequencyUpdater(){
	}
	
	/**
	 * Updates the sensor's frequency based on the Method3 algorithm from the AAMAS 2009 paper (Campbell and Wu).
	 *
	 * @param s the sensor
	 * @param sim the simulation that the sensor is in
	 */
	protected void update(final Sensor s, final Simulation sim){
		s.setFrequency(sim.random.nextInt(Agent.getNumFrequencies()));
	}
}