package sim.app.sensor_emitter;

/**
 * Contains the algorithm that controls where an emitter directs its emitted signal.
 * 
 * @author Adam Campbell
 */
abstract class SignalController{

	/**
	 * Specifies how an emitter controls its emitted signal.
	 *
	 * @param e emitter
	 * @param sim the simulation that the emitter is in
	 */
	protected abstract void controlSignal(final Emitter e, final Simulation sim);
}