package sim.util_amc;

/**
 * MathArrayFunctions contains various functions for arrays of numbers
 *
 * @author Adam Campbell
 */
public class MathArrayFunctions{

	/**
	 * computes the sum of values in an array of integers
	 *
	 * @return sum of numbers in given array
	 */
	public static int sum(int[] nums){
		int sum = 0;
		for(int i = 0; i < nums.length; i++){
			sum += nums[i];
		}
		return sum;
	}

	/**
	 * computes the sum of values in an array of doubles
	 *
	 * @return sum of numbers in given array
	 */
	public static double sum(double[] nums){
		double sum = 0;
		for(int i = 0; i < nums.length; i++){
			sum += nums[i];
		}
		return sum;
	}

	/**
	 * computes the average of the values in an array of integers
	 *
	 * @return average value of numbers in given array
	 */
	public static double average(int[] nums){
		return (double)MathArrayFunctions.sum(nums)/nums.length;
	}

	/**
	 * computes the average of the values in an array of doubles
	 *
	 * @return average value of numbers in given array
	 */
	public static double average(double[] nums){
		return MathArrayFunctions.sum(nums)/nums.length;
	}

	/**
	 * computes the standard deviation of the values in an array of integers
	 *
	 * @return standard deviation of numbers in given array
	 */
	public static double stdev(int[] nums){
		final double avg = MathArrayFunctions.average(nums);
		double val = 0.0;

		for(int i = 0; i < nums.length; i++){
			val += (nums[i]-avg)*(nums[i]-avg);
		}

		return Math.sqrt(val/(nums.length-1));

	}

	/**
	 * computes the standard deviation of the values in an array of doubles
	 *
	 * @return standard deviation of numbers in given array
	 */
	public static double stdev(double[] nums){
		final double avg = MathArrayFunctions.average(nums);
		double val = 0.0;

		for(int i = 0; i < nums.length; i++){
			val += (nums[i]-avg)*(nums[i]-avg);
		}

		return Math.sqrt(val/(nums.length-1));

	}

}